PHP异常处理浅析

PHP预定了两个异常类:Exception和ErrorException

Exception {
/* 属性 */
protected string $message ; //异常消息内容
protected int $code ; //异常代码号
protected string $file ; //抛出异常的文件名
protected int $line ; //抛出异常在该文件中的行号
/* 方法 */
public __construct ([ string $message = “” [, int $code = 0 [, Exception $previous = null]]] )
final public string getMessage ( void ) //异常抛出的信息
final public Exception getPrevious ( void ) //前一异常
final public int getCode ( void ) //异常代码,这是用户自定义的
final public string getFile ( void ) //发生异常的文件路劲
final public int getLine ( void ) //发生异常的行
final public array getTrace ( void ) //异常追踪信息(array)
final public string getTraceAsString ( void ) //异常追踪信息(string)
public string __toString ( void ) //试图直接 将异常对象当作字符串使用时调用子函数的返回值
final private void __clone ( void ) //克隆异常对象时调用
}

ErrorException extends Exception {

/* 属性 */
protected int $severity ;
/* 方法 */

public __construct ([ string $message = “” [, int $code = 0 [, int $severity = 1 [, string $filename = __FILE__ [, int $lineno = __LINE__ [, Exception $previous = NULL ]]]]]] )
final public int getSeverity ( void )
/* 继承的方法 */
final public string Exception::getMessage ( void )
final public Exception Exception::getPrevious ( void )
final public int Exception::getCode ( void )
final public string Exception::getFile ( void )
final public int Exception::getLine ( void )
final public array Exception::getTrace ( void )
final public string Exception::getTraceAsString ( void )
public string Exception::__toString ( void )
final private void Exception::__clone ( void )
}

那么如何捕获异常?

(1)PHP可用try…catch…捕获异常,进行异常处理的代码必须在try代码块内。

try {
throw new Exception(‘exception test 1’, 1001);
} catch(Exception $e) {
echo $e->getMessage().’-‘.$e->getCode();
}

(2)用户可以自定义异常处理函数[set_exception_handler],用于没用用try/catch捕获的异常。

function exception_handler ( $e ) {
echo “Uncaught exception: ” , $e -> getMessage (), “n” ;
}

set_exception_handler ( ‘exception_handler’ );

throw new Exception ( ‘Uncaught Exception’ );

echo “这行不会执行了”;

可以看到使用ser_exception_handler回调函数处理异常,后续的代码不会继续执行,但try-catch可以。
(3)PHP可用多catch捕获不同类型异常,并允许在catch代码块内再次抛出异常。

//请根据实际扩展异常类
class MyException extends Exception {
public function __construct($message = ”, $code = 0) {

}

public function myFunction() {
echo ‘just for test’;
}
}

try {
throw new MyException(‘an error’);
} catch (MyException $e) {
echo $e->myFunction();
} catch (Exception $e) {
echo $e->getMessage();
}

(4)PHP5.5已经支持finally关键词,你无需关心异常是否溢出了。

可对比如下:

function doSomething() {
$resource = createResource();
try {
$result = useResource($resource);
} catch (Exception $e) {
releaseResource($resource);
log($e->getMessage());
exit();
}
releaseResource($resource);
return $result;
}

//使用finally后
function doSomething2() {
$resource = createResource();
try {
$result = useResource($resource);
return $result;
} catch (Exception $e) {
log($e->getMessage());
exit();
} finally {
releaseResource($resource);
}
}

PHP异常处理浅析

郑重声明:本网站发布的内容(图片、视频和文字)以及用户投稿、用户转载内容为主,如果涉及侵权请尽快告知,我们将会在第一时间删除。文章观点不代表本网站立场,如需处理请联系客服

发表评论

登录后才能评论